/*---------------------------------------------------------------------*
        Copyright (C) 1998 Nintendo. (Originated by SGI)
        
        $RCSfile: playseq.h,v $
        $Revision: 1.12 $
        $Date: 1998/10/13 06:09:54 $
 *---------------------------------------------------------------------*/

#define	STACKSIZE	0x8000

#ifdef _LANGUAGE_C

/* #########################################################
 *
 *  MAX_VOICES defines the following numbers:
 *   - The number of physical voices of the synthesizer.
 *   - The number of virtual voices of the sequence player.
 *
 *  The greater the number of voices, the greater the number of sounds
 *  that can be played at the same time.  However, this also increases the 
 *  amount of processing by the CPU and the RSP.  Please optimize the
 *  value for each application.
 *
 *  This sample program supports the two following 
 *  MAX_VOICES definitions: 
 *
 *        #define MAX_VOICES 16; 
 *        #define MAX_VOICES 32; 
 *
 *  Please try both definitions to check the differences.
 *
 * ######################################################### */
#ifdef VOICES_16
#define MAX_VOICES      16
#else
#define MAX_VOICES      32
#endif

#define MAX_BUFFER_LENGTH 1024
#define DMA_QUEUE_SIZE  50
#define MAX_UPDATES     128
#define EVT_COUNT       128
#define FX_BUFFER_SIZE  8192
#define AUDIO_HEAP_SIZE 400000
#define MAX_CLIST_SIZE  5000
#define MAX_AUDIO_LENGTH 4096
#define OUTPUT_RATE     44100
#define EXTRA_SAMPLES   80              /* Extra samples to allow for jitter */
#define NUM_FIELDS      1
#define MAX_SEQ_LENGTH  50000

/*
 * Symbol generated by "makerom" to indicate the end of the code segment
 * in virtual (and physical) memory
 */
extern u8 _codeSegmentEnd[];

/*
 * Symbols generated by "makerom" to tell us where the segments are
 * in ROM.
 */
extern u8 _seqSegmentRomStart[], _seqSegmentRomEnd[];
extern u8 _midibankSegmentRomStart[], _midibankSegmentRomEnd[];
extern u8 _miditableSegmentRomStart[], _miditableSegmentRomEnd[];

#endif













